
uniform sampler2D mmv_tex0; //tH[It1+Fop[^+SPp[^
uniform sampler2D mmv_tex1; //XXXXXXXXXXXXXXXXXXX
uniform sampler2D mmv_tex2; //tH[It2
uniform sampler2D mmv_tex3; //RAt@+Gov+BXyL

varying vec3 VERTEX_NORMAL;	// @xNg
varying vec3 VERTEX_LIGHT;	// CgxNg
varying vec3 VERTEX_LIGHT2;	// CgxNg
varying vec3 VERTEX_EYE;	// xNg
void main( void )
{
	float	MAPs	=	512.0;				//eNX`}bvTCY
	float	BPP		=	5.0;				//ovx{
	vec2	ofst=	vec2((MAPs-2.0)/MAPs,1.0/MAPs);
//	vec3	N	= normalize(VERTEX_NORMAL);	// @xNg
	vec3	L	= normalize(VERTEX_LIGHT);	// CgxNg
	vec3	L2	= normalize(VERTEX_LIGHT2);	// CgxNg
	vec3	E	= normalize(VERTEX_EYE);	// xNg
	float	ad  = texture2D( mmv_tex3, gl_TexCoord[ 0 ].st ).g;		//AD
	vec2	Tex		= gl_TexCoord[ 0 ].xy+vec2(0.01*ad*-E);	
	vec3	Tex1	=	texture2D( mmv_tex0, Tex.st ).rgb;			//tH[It1eNX`
	vec3	Tex2	=	texture2D( mmv_tex2, Tex.st ).rgb;			//tH[It2eNX`
	vec3	abs		=	texture2D( mmv_tex3, Tex.st ).rgb;          //At@+ov+XyL
	vec3    N		=	vec3(abs.g).rgb;                            //ov2
	vec3	NM_L	= vec3(texture2D( mmv_tex3, vec2( Tex.s - 1.0 / MAPs, Tex.t ) ).g);
	vec3	NM_T	= vec3(texture2D( mmv_tex3, vec2( Tex.s, Tex.t - 1.0 / MAPs ) ).g);
			N		=normalize(VERTEX_NORMAL*pow(vec3( NM_L.x - N.x, NM_T.x - N.x, NM_L.x-NM_T.x )+vec3(1),vec3(BPP)));//ovtN
	float	dif		= max( dot( N, L), 0.0 );			//gUxi̋j
			dif		+=max( dot( N, L2 ), 0.0 ) * 0.3;	//gUx2i̋j
			dif		= min( dif + 0.1, 1.0 )*ofst.x+ofst.y;	//ItZbg;
	vec3	FOP		= texture2D( mmv_tex0, vec2( dif, 1.0/MAPs ) ).rgb;
//	float	FOP		= texture2D( mmv_tex0, vec2( dif, 1.0/MAPs ) ).r;
	float	spec	= (max( dot( reflect( L, N ), E ), 0.0 )*abs.b)*ofst.x+ofst.y;
	vec3	spec2	= pow(texture2D( mmv_tex0, vec2( spec,(MAPs-1.0)/MAPs) ).rgb,vec3(1.0));
	gl_FragColor	= vec4(mix(Tex2,Tex1,FOP).rgb+vec3(spec2),abs.r );

	if(normalize(VERTEX_NORMAL).b < 0.2 ){
		gl_FragColor	+= vec4( vec3(-0.7), 0 );
	}//o---------
}
